# frozen_string_literal: true

require "pathname"

module Doctrine
  require_relative "doctrine/context"
  require_relative "doctrine/definition"
  require_relative "doctrine/suite"
  require_relative "doctrine/version"

  def self.load(path, pattern: "*_doctrine.rb")
    path = Pathname(path).expand_path
    name = path.to_s.split("/").last(2)
    suite = Suite.define(*name)
    context = Context.new(suite: suite)

    suite.makes(:doctrine, Definition, within: name)
    suite.loads(:doctrine, path, strict: false, pattern: pattern, context: context)
    suite.load
    suite
  end
end
