# frozen_string_literal: true

require "core/loader/context"

module Doctrine
  # [public]
  #
  class Context
    def initialize(suite:)
      @suite = suite
    end

    # [public]
    #
    def doctrine(...)
      @context.doctrine(...).tap { |doctrine|
        @suite.doctrines << doctrine
      }
    end

    # [public]
    #
    def load(...)
      self.class.new(suite: @suite).internal_load(...)
    end

    def internal_load(path:, root:, type:, target:, strict:)
      @context = Core::Loader::Context.new(path: path, root: root, type: type, target: target, strict: strict)

      eval(path.read, binding, path.to_s)
    end

    # def method_missing(method, *name, **kwargs, &block)
    #   if method == :tenet
    #     @context.__send__(method, *name, block: block, **kwargs).tap { |tenet|
    #       @suite.tenets << tenet
    #     }
    #   else
    #     @context.__send__(method, *name, **kwargs, &block)
    #   end
    # end

    # def respond_to_missing?(name, include_private = false)
    #   @context.respond_to_missing?(name, include_private) || ::Kernel.respond_to?(name, include_private)
    # end

    # def self.const_missing(name)
    #   ::Object.const_get(name)
    # end
  end
end
