# frozen_string_literal: true

module Doctrine
  # [public]
  #
  class Run
    def initialize(doctrine:, tenet:)
      @doctrine = doctrine
      @tenet = tenet
      @error = nil
    end

    # [public]
    #
    attr_reader :error

    # [public]
    #
    def perform
      @doctrine.new.instance_eval(&@tenet.block)
    rescue => error
      errored(error)
    end

    # [public]
    #
    def errored?
      !@error.nil?
    end

    # [public]
    #
    def errored(error)
      @error = error
    end
  end
end
