# frozen_string_literal: true

module Doctrine
  # [public]
  #
  class Worker
    def initialize(queue:, runner:)
      @queue = queue
      @runner = runner
    end

    # [public]
    #
    def run
      until @queue.closed?
        if (run = @queue.pop)
          begin
            @runner.starting(run)

            run.perform
          rescue => error
            run.errored(error)
          ensure
            @runner.finished(run)
          end
        end
      end
    end
  end
end
